#!/bin/bash
CURRENT_ARCH="xxx"

driver_to_build_env()
{
	config=$1
	if [ $config = "mv_xor" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "iop-adma" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "imx3-ipu" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "at_hdmac" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "coh" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "dma40" ]; then
		arch=arm
		cross="ccache arm-none-linux-gnueabi-"
	elif [ $config = "ioat" ]; then
		arch=x86
		cross=""
	elif [ $config = "fsldma" ]; then
		arch=powerpc
		cross="ccache powerpc-linux-gnu-"
	elif [ $config = "mpc512x" ]; then
		arch=powerpc
		cross="ccache powerpc-linux-gnu-"
	elif [ $config = "ppc44x" ]; then
		arch=powerpc
		cross="ccache powerpc-linux-gnu-"
	elif [ $config = "dw_dmac" ]; then
		arch=avr32
		cross="ccache avr32-linux-"
	elif [ $config = "txx9" ]; then
		arch=mips
		cross="ccache mips-linux-gnu-"
	elif [ $config = "sh_dma" ]; then
		arch=sh
		cross="ccache sh4-unknown-linux-gnu-"
	else
		echo "unknown config: $config"
		exit 2
	fi
}

config()
{
	driver=$1
	driver_to_build_env $driver

	if [ $CURRENT_ARCH != $arch ]; then
		make mrproper > /dev/null 2>&1
	fi

	CURRENT_ARCH=$arch

	cp configs/$driver ./.config
	#make ARCH=$arch oldconfig > /dev/null 2>&1
	while true; do echo ""; done | make ARCH=$arch oldconfig > /dev/null 2>&1
}

build()
{
	driver=$1
	target=$2
	echo "--=== BUILDING DRIVER($driver) TARGET($target) ===--"
	driver_to_build_env $driver
	if ! make -s ARCH=$arch CROSS_COMPILE="$cross" -j 8 $target; then
		echo "!!!!!!"
		echo "build failed: driver: $driver target: $target"
		echo "!!!!!!"
		exit 2
	fi
}

#drivers="ioat dw_dmac coh dma40 mv_xor iop-adma imx3-ipu mpc512x fsldma ppc44x at_hdmac txx9 sh_dma"
drivers="dma40"
targets="drivers/dma/ crypto/async_tx/ drivers/md/ drivers/mmc/ drivers/dca/ drivers/video/ drivers/idle/"

for i in $drivers; do
	config $i
	for j in $targets; do
		build $i $j
	done
done
